#!/usr/bin/env python
import game as board
FILLWEIGHT=4.0
FULLWEIGHT=100
TOPWEIGHT=6
BUMPWEIGHT=2
EMPTYWEIGHT=2
HOLEWEIGHT=0.01


def countones(l):
    n=0
    while l:
       n+=l&1
       l=l>>1
    return n 
    #return bin(l).count('1')


def topfree(b):
    bmap=b.bmap
    h=0
    full=2**(b.w)-1
    for i in xrange(b.h):
        if bmap&full==0:
            h+=1
            bmap=bmap>>b.w
        else:
            return h
    return b.h


def changecount(l, size):
    if size<64:
        l = int(l)  # try to downgrade into simple int
        n = 0
        last = l & 1
        for _ in xrange(size):
            v = l & 1
            n += int(v ^ last)
            last = v
            l >>= 1
        return n
    else:
        return changecount_str(l,size)
        
def changeones(l,size):
        l = int(l)  # try to downgrade into simple int
        n = 0
        o = 0
        last = l & 1
        while l:
            v = l & 1
            n += int(v ^ last)
            last = v
            l >>= 1
            o+=v
        return n,o


def changecount_str(l,size, debug=False):
    a=bin(l)[2:]
    if len(a)<size:
        last='0'
    else:
        last='1'
    co=0
    if debug:
        print 'cc last', last
    for i in a:
        if debug:
            print 'cc i', i
        if i!=last:
            co+=1
            last=i
    return co


def holes(lines):
    # holes under double cover
    holes = 0
    for i in xrange(len(lines) - 2):
        up1 = lines[i]
        up2 = lines[i + 1]
        down = lines[i + 2]
        up = up1 & up2
        # print bin(up)
        # print bin(down)
        holes += countones(up & (up ^ down))
    return holes


def value(b, debug=False,y=None,size=0):
    fillfactor = 0
    fulllines = 0
    nonempty = 0
    bumps = 0.0
    emptycount = 0

    remboard = b.bmap
    tf = topfree(b)
    remboard >>= b.w * tf
    full = 2**(b.w)-1
    
    # lines = []
    # for height in xrange(b.h - tf):
    #     line = int(remboard & full)
    #     lines.append(line)
    #     remboard = remboard >> b.w
    
    if (b.w>64 and tf<b.h/2) or (y!=None or y<tf-size-2):
        #print 'zhopa'
        return -tf*TOPWEIGHT
    for height in xrange(b.h - tf):
        line = int(remboard & full)
        remboard = remboard >> b.w
        if line != 0:
            #empty line
            nonempty += 1
            cbumps,ones=changeones(line,b.w)
            if line == full:
                fulllines += 1 #*(float(height)+tf)/b.h
            else:
                #fillfactor += (float(countones(line))/b.w)**2 #*(float(height)+tf)
                fillfactor += (float(ones)/b.w)**2 #*(float(height)+tf)
            bumps += float(cbumps)
        else:
            emptycount += 1

    # holes_n = holes(lines)
    res = 0
    # res += holes_n * HOLEWEIGHT
    res += -fulllines * FULLWEIGHT
    res += -tf * TOPWEIGHT
    res += -emptycount * EMPTYWEIGHT

    if nonempty!=0:
        res += -fillfactor/nonempty*FILLWEIGHT
        res += bumps/nonempty*BUMPWEIGHT

    if debug:
        print 'bumps', bumps
        print 'full_lines', fulllines
        print 'empty_count', emptycount
        print 'nonempty', nonempty
        # print 'holes', holes_n
        print 'tf', tf
    return res

if __name__=='__main__':
    a=board.Board(10,10,[(0,1)])
    print a.show()
    print value(a, debug=True)
    
    a=board.Board(10,10,[(1,0)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(9,2)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(1,9)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(2,8), (1,9)])
    print a.show()
    print value(a, debug=True)
    print changeones (0b00000,5)
    print changeones (0b11111,5)
    print changeones (0b10101,5)
    print changeones (0b01010,5)
    