#!/usr/bin/env python
import game as board

FILLWEIGHT=4.0
FULLWEIGHT=100
TOPWEIGHT=6
BUMPWEIGHT=2
EMPTYWEIGHT=2
HOLEWEIGHT=0.01


def countones(l):
    return bin(l).count('1')


def topfree(b):
    bmap=b.bmap
    h=0
    full=2**(b.w)-1
    for i in xrange(b.h):
        if bmap&full==0:
            h+=1
            bmap=bmap>>b.w
        else:
            return h
    return b.h


def changecount(l, size):
    l = int(l)  # try to downgrade into simple int
    n = 0
    last = l & 1
    for _ in xrange(size):
        v = l & 1
        n += int(v ^ last)
        last = v
        l >>= 1
    return n


def changecount_str(l,size, debug=False):
    a=bin(l)[2:]
    if len(a)<size:
        last='0'
    else:
        last='1'
    co=0
    if debug:
        print 'cc last', last
    for i in a:
        if debug:
            print 'cc i', i
        if i!=last:
            co+=1
            last=i
    return co


def holes(lines):
    # holes under double cover
    holes = 0
    for i in xrange(len(lines) - 2):
        up1 = lines[i]
        up2 = lines[i + 1]
        down = lines[i + 2]
        up = up1 & up2
        # print bin(up)
        # print bin(down)
        holes += countones(up & (up ^ down))
    return holes


def value(b, debug=False,y=None,size=None):

    remboard = b.bmap
    full = 2**(b.w)-1
    maxline=0

    for height in xrange(b.h):
        line=remboard&full
        remboard=remboard>>b.w
        currline=countones(line)
        if currline>maxline:
            maxline=currline

    return -maxline

if __name__=='__main__':
    a=board.Board(10,10,[(0,1)])
    print a.show()
    print value(a, debug=True)
    
    a=board.Board(10,10,[(1,0)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(9,2)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(1,9)])
    print a.show()
    print value(a, debug=True)

    a=board.Board(10,10,[(2,8), (1,9)])
    print a.show()
    print value(a, debug=True)
