#!/usr/bin/env python
#from game import MUTATION_TO_CMD,E,W,SE,SW,CW,CCW

W = 'p'
E = 'b'
SW = 'a'
SE = 'l'
CW = 'd'
CCW = 'k'
NOP = '\t'

CMD_TO_MUTATIONS = {
    W: "p'!.03",
    E: 'bcefy2',
    SW: 'aghij4',
    SE: 'lmno 5',
    CW: 'dqrvz1',
    CCW: 'kstuwx',
    NOP: '\t\n\r'
}

MUTATION_TO_CMD = {m: c
                   for c, ms in CMD_TO_MUTATIONS.items()
                   for m in ms + ms.upper()}

def reqsym(pword):
    word=map(lambda x:MUTATION_TO_CMD[x],pword)
    poslist=[(0,0,0)]
    for i in word:
        oldpos=poslist[-1]
        if i==E:
            newpos=(oldpos[0]+1,oldpos[1],oldpos[2])
        if i==W:
            newpos=(oldpos[0]-1,oldpos[1],oldpos[2])
        if i==SE or i==SW:#doesn't matter for symmetry or validity
            newpos=(oldpos[0],oldpos[1]+1,oldpos[2])
        if i==CW:
            newpos=(oldpos[0],oldpos[1],(oldpos[2]+1)%6)
        if i==CCW:
            newpos=(oldpos[0],oldpos[1],(oldpos[2]-1)%6)
        poslist.append(newpos)   
    poslen=len(poslist)
    set6=set(poslist)
    if len(set6)<poslen:
        return 999
    set3=set(map(lambda x:(x[0],x[1],x[2]%3),poslist))
    if len(set3)<poslen:
        return 6
    set2=set(map(lambda x:(x[0],x[1],x[2]%2),poslist))
    if len(set2)<poslen:
        return 3
    set1=set(map(lambda x:(x[0],x[1],x[2]%1),poslist))
    if len(set1)<poslen:
        return 2
        
    return 1
    
        
if __name__=='__main__':
    for i in ["ph'nglui mglw'nafh cthulhu r'lyeh wgah'nagl fhtagn.","ei!ei!","chtulhu",'euu','euueuu','evv','evvvv','evvvvv','ev','evvvvvv','evvvvvuuuuu']:
        print i, reqsym(i)