import os
import sys
import tty
import termios

def getch():
    fd = sys.stdin.fileno()
    old_settings = termios.tcgetattr(fd)
    try:
        tty.setraw(sys.stdin.fileno())
        ch = sys.stdin.read(1)
    finally:
        termios.tcsetattr(fd, termios.TCSADRAIN, old_settings)
        if ch == '\x03':
            sys.exit(-1)
        return ch

def get_qualifiers():
    taskpath = "qualifiers"
    files = [os.path.join(taskpath,f) for f in os.listdir(taskpath)]
    return [f for f in files if os.path.isfile(f)]

